import java.awt.*;
import java.awt.event.*;

class RedrawThread extends Thread {
	TestFrame a;
	Color actual_color;
	int k = 0;
	
	boolean stop;
	
	int x,y,dx,dy, w,h;
	final int s = 20;
	
	RedrawThread (TestFrame a, Color c, int k){
		this.a = a;
		actual_color = c;
		this.k = k;
		
		w = this.a.getWidth() -1;
		h = this.a.getHeight() -1;
		
		x = w/2;
		y = s;
		dx = 1;
		dy = 15;
		stop = false;
		
		start();
	}
	
	public void run() {
		while (!stop){
			if (x + dx < s) 
				dx = -dx;
			if (x > w - s - 1)
				dx = -dx;
			if (y + dy < s)
				dy = 20;
			x+=dx;
			y+=dy;
			dy--;
			try {
				sleep(this.k);
			}
			catch (Exception e) {
			}
			this.a.setCoordinates(x,y,actual_color);
			this.a.repaint();
			
		}
	}

}

class TestFrame extends Frame {
	RedrawThread a,b;
	
	Color c1;
	Color c2;
	
	int x1, y1;
	int x2, y2;
	int w,h;
	final int s = 20;
	
	public TestFrame() {
		setSize(500,500);
		a = new RedrawThread(this, Color.blue, 20);
		b = new RedrawThread(this, Color.red, 30);
		w = a.w;
		h = a.h;
		x1 = a.x;
		y1 = a.y;
		c1 = a.actual_color;
		x2 = b.x;
		y2 = b.y;
		c2 = b.actual_color; 
		setVisible(true);
	}
	
	public void setCoordinates(int x, int y, Color c) {
		if (c.equals(Color.blue)) {
			x1 = x;
			y1 = y;
			c1 = Color.blue;
		}
		if (c.equals(Color.red)) {
			x2 = x;
			y2 = y;
			c2 = Color.red;
		}
	}
	
	public void paint (Graphics g) {
		g.setColor(c1);
		g.fillOval(x1-s,h-y1-s,2*s,2*s);
		g.setColor(c2);
		g.fillOval(x2-s,h-y2-s,2*s,2*s);
	}
}

public class TwoThreadsGraphics {
	public static void main (String args[]) {
		new TestFrame();
	}
}